;MISh add-on file for the shell
;February 20, 1998

;Graph Screen Macros (Shouldn't affect ASM at all)
#DEFINE GUSE_GRAPH		res 0,(IY+$03)
#DEFINE GREDRAW_GRAPH		set 0,(IY+$03)
#DEFINE GLABELS_ON		set 6,(IY+$04)
#DEFINE GLABELS_OFF		res 6,(IY+$04)
#DEFINE GAXES_OFF		set 5,(IY+$04)
#DEFINE GAXES_ON		res 5,(IY+$04)
#DEFINE GCURSOR_OFF		set 4,(IY+$04)
#DEFINE GCURSOR_ON		res 4,(IY+$04)
#DEFINE GPOLAR_GC		set 3,(IY+$04)
#DEFINE GRECT_GC		res 3,(IY+$04)
#DEFINE GGRID_ON		set 2,(IY+$04)
#DEFINE GGRID_OFF		res 2,(IY+$04)
#DEFINE GSIMUL_G		set 1,(IY+$04)
#DEFINE GSEQ_G			res 1,(IY+$04)
#DEFINE GDRAW_DOT		set 0,(IY+$04)
#DEFINE GDRAW_LINE		res 0,(IY+$04)

;Printing option macros
#DEFINE	PB_ON_W			res 3,(IY+$05)
#DEFINE PW_ON_B			set 3,(IY+$05)
#DEFINE PM7_ROWS		set 1,(IY+$05)
#DEFINE PM6_ROWS		res 1,(IY+$05)
#DEFINE PSCROLL			set 2,(IY+$0D)
#DEFINE PNO_SCROLL		res 2,(IY+$0D)
#DEFINE PAFFECT_TEXT		set 1,(IY+$0D)
#DEFINE PNO_AFFECT_TEXT		res 1,(IY+$0D)

;Useful Misc. Command Macros:
#DEFINE APD_ON			set 3,(iy+8) ; Turns APD on!  Wow!
#DEFINE APD_OFF			res 3,(iy+8) ; Turns APD off!  Wow!

;rst commands
#DEFINE SEARCH_VAT		rst 10H	; Searches VAT for Variable (rst)
#DEFINE LD_OP1_HL		rst 20H	; OP1=(HL) (rst)

;Straight ROM Calls:
D_COLON		=$0094	; displays a : at normal text cursor
UPDATE_BUSY	=$00AC	; update busy counter & redraw bitmap
READ_KEYPAD	=$01A2	; read key directly from port
APD_RESET       =$0115  ; resets $8009 to $A1

;Straight ROM Jumps
HOME_SCREEN	=$0462	; jump to home screen, and display contents of
			; TEXT_MEM as ascii equivalents

;Data Areas
APD_COUNTER	=$8008	; 2 byte counter used for APD
BLINK_COUNTER	=$800A	; 2 byte counter used for blinking cursors
DELCHAR_LEN	=$800F	; length of DELCHAR buffer (max 100)
DELCHAR_BUF	=$8010	; 100 byte buffer for copy/paste in program editor
OP1		=$8082	; OP1 register for variable manipulators
OP2		=$808D	; OP2 register for variable manipulators
OP3		=$8098	; OP3 register for variable manipulators
OP4		=$80A3	; OP4 register for variable manipulators
OP5		=$80AE	; OP5 register for variable manipulators
OP6		=$80B9	; OP6 register for variable manipulators
SCROLL_START	=$8B2F	; first row of scrolling for SCROLL_UP
SCROLL_END	=$8B30	; last row of scrolling for SCROLL_UP

;MISh ROM call indexes
GRAPH2LCD	=$0F	; copy Graph 2 LCD
D_MEMU		=$10	; display menu indexed by A
CLR_WINDOW	=$11	; clear scrolling window
CLEAR_LINE	=$12	; clear from cursor to end of line
C2TOP		=$13	; set cursor to top of scrolling window
KEY_HANDLER	=$14	; GET_KEY with contrast control, etc.
D_HEADING	=$15	; print zero term. string at 0,0 & clear rest of line
SAVE_PRINT	=$16	; save printing parameters in secondary area
SAVE_TEXT	=$17	; save printing parameters in secondary area & save
			; TEXT_MEM in secondary area

;Internal MISh routines (Straight Call Functions):
EXE		=$8C41	; input: (OP1)=Variable data, Output: Run the program
			; after checking header
SET_DEF		=$8C44	; set defaults for program execution
CHECK_HEADER	=$8C47	; check for ZShell 4.0 header at (HL)
F_B_BYTES	=$8C4A	; fill B bytes with A at (HL)

